Bio::DB::SeqFeature::Store::GFF3Loader(3)

NAME
Bio::DB::SeqFeature::Store::GFF3Loader -- GFF3 file loader for Bio::DB::SeqFeature::Store

SYNOPSIS
  use Bio::DB::SeqFeature::Store;
  use Bio::DB::SeqFeature::Store::GFF3Loader;

  # Open the sequence database
  my $db      = Bio::DB::SeqFeature::Store->new( -adaptor => 'DBI::mysql',
                                                 -dsn     => 'dbi:mysql:test',
                                                 -write   => 1 );

  my $loader = Bio::DB::SeqFeature::Store::GFF3Loader->new(-store    => $db,
                                                           -verbose  => 1,
                                                           -fast     => 1);

  $loader->load('./my_genome.gff3');

DESCRIPTION
The Bio::DB::SeqFeature::Store::GFF3Loader object parsers GFF3-format sequence annotation files and loads Bio::DB::SeqFeature::Store databases. For certain combinations of SeqFeature classes and SeqFeature::Store databases it features a "fast load" mode which will greatly accelerate the loading of GFF3 databases by a factor of 5-10.

The GFF3 file format has been extended very slightly to accomodate Bio::DB::SeqFeature::Store. First, the loader recognizes is a new directive:

  # #index-subfeatures [0|1]

Note that you can place a space between the two #'s in order to prevent GFF3 validators from complaining.

If this is true, then subfeatures are indexed (the default) so that they can be retrieved with a query. See Bio::DB::SeqFeature::Store for an explanation of this. If false, then subfeatures can only be accessed through their parent feature.

Second, the loader recognizes a new attribute tag called index, which if present, controls indexing of the current feature. Example:

 ctg123 . TF_binding_site 1000 1012 . + . ID=tfbs00001;index=1

You can use this to turn indexing on and off, overriding the default for a particular feature.

Note that the loader keeps a record -- in memory -- of each feature that it has processed. If you find the loader running out of memory on particularly large GFF3 files, please split the input file into smaller pieces and do the load in steps.

  new
 Title   : new
 Usage   : $loader = Bio::DB::SeqFeature::Store::GFF3Loader->new(@options)
 Function: create a new parser
 Returns : a Bio::DB::SeqFeature::Store::GFF3Loader gff3 parser and loader
 Args    : several - see below
 Status  : public

This method creates a new GFF3 loader and establishes its connection with a Bio::DB::SeqFeature::Store database. Arguments are -name=>$value pairs as described in this table:

 Name               Value
 ----               -----

 -store             A writeable Bio::DB::SeqFeature::Store database handle.

 -seqfeature_class  The name of the type of Bio::SeqFeatureI object to create
                      and store in the database (Bio::DB::SeqFeature by default)

 -sf_class          A shorter alias for -seqfeature_class

 -verbose           Send progress information to standard error.

 -fast              If true, activate fast loading (see below)

 -chunk_size        Set the storage chunk size for nucleotide/protein sequences
                       (default 2000 bytes)

 -tmp               Indicate a temporary directory to use when loading non-normalized
                       features.

 -ignore_seqregion  Ignore ##sequence-region directives. The default is to create a
                       feature corresponding to the directive.

When you call new(), a connection to a Bio::DB::SeqFeature::Store database should already have been established and the database initialized (if appropriate).

Some combinations of Bio::SeqFeatures and Bio::DB::SeqFeature::Store databases support a fast loading mode. Currently the only reliable implementation of fast loading is the combination of DBI::mysql with Bio::DB::SeqFeature. The other important restriction on fast loading is the requirement that a feature that contains subfeatures must occur in the GFF3 file before any of its subfeatures. Otherwise the subfeatures that occurred before the parent feature will not be attached to the parent correctly. This restriction does not apply to normal (slow) loading.

If you use an unnormalized feature class, such as Bio::SeqFeature::Generic, then the loader needs to create a temporary database in which to cache features until all their parts and subparts have been seen. This temporary databases uses the "berkeleydb" adaptor. The -tmp option specifies the directory in which that database will be created. If not present, it defaults to the system default tmp directory specified by File::Spec->tmpdir().

The -chunk_size option allows you to tune the representation of DNA/Protein sequence in the Store database. By default, sequences are split into 2000 base/residue chunks and then reassembled as needed. This avoids the problem of pulling a whole chromosome into memory in order to fetch a short subsequence from somewhere in the middle. Depending on your usage patterns, you may wish to tune this parameter using a chunk size that is larger or smaller than the default.

  ignore_seqregion
  $ignore_it = $loader->ignore_seqregion([$new_flag])

Get or set the ignore_seqregion flag, which if true, will cause GFF3 ##sequence-region directives to be ignored. The default behavior is to create a feature corresponding to the region.

  load
 Title   : load
 Usage   : $count = $loader->load(@ARGV)
 Function: load the indicated files or filehandles
 Returns : number of feature lines loaded
 Args    : list of files or filehandles
 Status  : public

Once the loader is created, invoke its load() method with a list of GFF3 or FASTA file paths or previously-opened filehandles in order to load them into the database. Compressed files ending with .gz, .Z and .bz2 are automatically recognized and uncompressed on the fly. Paths beginning with http: or ftp: are treated as URLs and opened using the LWP GET program (which must be on your path).

FASTA files are recognized by their initial ">" character. Do not feed the loader a file that is neither GFF3 nor FASTA; I don't know what will happen, but it will probably not be what you expect.

  accessors
The following read-only accessors return values passed or created during new():

 store()          the long-term Bio::DB::SeqFeature::Store object

 tmp_store()      the temporary Bio::DB::SeqFeature::Store object used
                    during loading

 sfclass()        the Bio::SeqFeatureI class

 fast()           whether fast loading is active

 seq_chunk_size() the sequence chunk size

 verbose()        verbose progress messages

  Internal Methods
The following methods are used internally and may be overidden by subclasses.

default_seqfeature_class
      $class = $loader->default_seqfeature_class

    Return the default SeqFeatureI class (Bio::DB::SeqFeature).

subfeatures_normalized
      $flag = $loader->subfeatures_normalized([$new_flag])

    Get or set a flag that indicates that the subfeatures are normalized. This is deduced from the SeqFeature class information.

subfeatures_in_table
      $flag = $loader->subfeatures_in_table([$new_flag])

    Get or set a flag that indicates that feature/subfeature relationships are stored in a table. This is deduced from the SeqFeature class and Store information.

load_fh
      $count = $loader->load_fh($filehandle)

    Load the GFF3 data at the other end of the filehandle and return true if successful. Internally, load_fh() invokes:

      start_load();
      do_load($filehandle);
      finish_load();

start_load, finish_load
    These methods are called at the start and end of a filehandle load.

do_load
      $count = $loader->do_load($fh)

    This is called by load_fh() to load the GFF3 file's filehandle and return the number of lines loaded.

load_line
        $loader->load_line($data);

    Load a line of a GFF3 file. You must bracket this with calls to start_load() and finish_load()!

        $loader->start_load();
        $loader->load_line($_) while <FH>;
        $loader->finish_load();

handle_meta
      $loader->handle_meta($meta_directive)

    This method is called to handle meta-directives such as ##sequence-region. The method will receive the directive with the initial ## stripped off.

handle_feature
      $loader->handle_feature($gff3_line)

    This method is called to process a single GFF3 line. It manipulates information stored a data structure called $self->{load_data}.

allow_whitespace
       $allow_it = $loader->allow_whitespace([$newvalue]);

    Get or set the allow_whitespace flag. If true, then GFF3 files are allowed to be delimited with whitespace in addition to tabs.

store_current_feature
      $loader->store_current_feature()

    This method is called to store the currently active feature in the database. It uses a data structure stored in $self->{load_data}.

build_object_tree
     $loader->build_object_tree()

    This method gathers together features and subfeatures and builds the graph that connects them.

build_object_tree_in_tables
     $loader->build_object_tree_in_tables()

    This method gathers together features and subfeatures and builds the graph that connects them, assuming that parent/child relationships will be stored in a database table.

build_object_tree_in_features
     $loader->build_object_tree_in_features()

    This method gathers together features and subfeatures and builds the graph that connects them, assuming that parent/child relationships are stored in the seqfeature objects themselves.

attach_children
     $loader->attach_children($store,$load_data,$load_id,$feature)

    This recursively adds children to features and their subfeatures. It is called when subfeatures are directly contained within other features, rather than stored in a relational table.

fetch
     my $feature = $loader->fetch($load_id)

    Given a load ID (from the ID= attribute) this method returns the feature from the temporary database or the permanent one, depending on where it is stored.

add_segment
     $loader->add_segment($parent,$child)

    This method is used to add a split location to the parent.

parse_attributes
     ($reserved,$unreserved) = $loader->parse_attributes($attribute_line)

    This method parses the information contained in the $attribute_line into two hashrefs, one containing the values of reserved attribute tags (e.g. ID) and the other containing the values of unreserved ones.

start_or_finish_sequence
      $loader->start_or_finish_sequence('Chr9')

    This method is called at the beginning and end of a fasta section.

load_sequence
      $loader->load_sequence('gatttcccaaa')

    This method is called to load some amount of sequence after start_or_finish_sequence() is first called.

open_fh
     my $io_file = $loader->open_fh($filehandle_or_path)

    This method opens up the indicated file or pipe, using some intelligence to recognized compressed files and URLs and doing the right thing.

time
     my $time = $loader->time

    This method returns the current time in seconds, using Time::HiRes if available.

unescape
     my $unescaped = GFF3Loader::unescape($escaped)

    This is an internal utility. It is the same as CGI::Util::unescape, but doesn't change pluses into spaces and ignores unicode escapes.

local_ids
     my $ids    = $self->local_ids;
     my $id_cnt = @$ids;

    After performing a load, this returns an array ref containing all the load file IDs that were contained within the file just loaded.

loaded_ids
     my $ids    = $loader->loaded_ids;
     my $id_cnt = @$ids;

    After performing a load, this returns an array ref containing all the feature primary ids that were created during the load.

BUGS
This is an early version, so there are certainly some bugs. Please use the BioPerl bug tracking system to report bugs.

SEE ALSO
Bio::DB::SeqFeature::Store, Bio::DB::SeqFeature::Segment, Bio::DB::SeqFeature::NormalizedFeature, Bio::DB::SeqFeature::GFF2Loader, Bio::DB::SeqFeature::Store::DBI::mysql, Bio::DB::SeqFeature::Store::berkeleydb

AUTHOR
Lincoln Stein <lstein@cshl.org>.

Copyright (c) 2006 Cold Spring Harbor Laboratory.

This library is free software; you can redistribute it and/or modify it under the same terms as Perl itself.